package tools.descartes.dql.connector.kieker.structures;

import java.util.ArrayList;

public abstract class AbstractValue<Data> {
	
	private ArrayList<TimeDataPair<Long, Data>> esssentialValuesArrayList = new ArrayList<TimeDataPair<Long,Data>>();
	private TimeDataPair<Long, Data> currentSignPair;
	
	public void put(long timestamp, Data d){
		currentSignPair = new TimeDataPair<Long, Data>(timestamp,d);
		esssentialValuesArrayList.add(currentSignPair);
	}
	
	public long getCurrentTimestamp(){
		return currentSignPair.getTime();
	}
	
	public Data getCurrentData(){
		return currentSignPair.getData();
	}
	
	public ArrayList<TimeDataPair<Long, Data>> getArrayList(){
		return esssentialValuesArrayList;
	}
	
	public void clearAll(){
		esssentialValuesArrayList = new ArrayList<TimeDataPair<Long,Data>>();
		currentSignPair = null;
	}
	
	@SuppressWarnings("hiding")
	public class TimeDataPair<Sign,Data> {

		private final Sign sign;
		private Data data;

		public Data getData() {
			return data;
		}
		public Sign getTime() {
			return sign;
		}
		public void setData(Data data) {
			this.data = data;
		}

		public TimeDataPair(Sign s, Data d) {
			this.sign=s;
			this.data=d;
		}

		public String toString() {

			return "$" + sign.toString() + "\t| " + data.toString();
		}
	}

}
